
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class Article_bookmarksDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const article_bookmarks = await db.article_bookmarks.create(
            {
                id: data.id || undefined,
        
        bookmarked_at: data.bookmarked_at
        ||
        null
            ,
            
        note: data.note
        ||
        null
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await article_bookmarks.setUser( data.user || null, {
            transaction,
        });
        
        await article_bookmarks.setNews_article( data.news_article || null, {
            transaction,
        });
        

        

        

        return article_bookmarks;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const article_bookmarksData = data.map((item, index) => ({
                id: item.id || undefined,
                
                bookmarked_at: item.bookmarked_at
            ||
            null
            ,
            
                note: item.note
            ||
            null
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const article_bookmarks = await db.article_bookmarks.bulkCreate(article_bookmarksData, { transaction });

        // For each item created, replace relation files
        

        return article_bookmarks;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        

        const article_bookmarks = await db.article_bookmarks.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.bookmarked_at !== undefined) updatePayload.bookmarked_at = data.bookmarked_at;
        
        
        if (data.note !== undefined) updatePayload.note = data.note;
        
        
        updatePayload.updatedById = currentUser.id;

        await article_bookmarks.update(updatePayload, {transaction});

        
        
        if (data.user !== undefined) {
            await article_bookmarks.setUser(
              
              data.user,
              
              { transaction }
            );
        }
        
        if (data.news_article !== undefined) {
            await article_bookmarks.setNews_article(
              
              data.news_article,
              
              { transaction }
            );
        }
        

        
        

        

        return article_bookmarks;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const article_bookmarks = await db.article_bookmarks.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of article_bookmarks) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of article_bookmarks) {
                await record.destroy({transaction});
            }
        });


        return article_bookmarks;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const article_bookmarks = await db.article_bookmarks.findByPk(id, options);

        await article_bookmarks.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await article_bookmarks.destroy({
            transaction
        });

        return article_bookmarks;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const article_bookmarks = await db.article_bookmarks.findOne(
            { where },
            { transaction },
        );

        if (!article_bookmarks) {
            return article_bookmarks;
        }

        const output = article_bookmarks.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.user = await article_bookmarks.getUser({
            transaction
        });
        
        
        output.news_article = await article_bookmarks.getNews_article({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        

        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.users,
        as: 'user',
        
        where: filter.user ? {
          [Op.or]: [
            { id: { [Op.in]: filter.user.split('|').map(term => Utils.uuid(term)) } },
            {
              firstName: {
                [Op.or]: filter.user.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.news_articles,
        as: 'news_article',
        
        where: filter.news_article ? {
          [Op.or]: [
            { id: { [Op.in]: filter.news_article.split('|').map(term => Utils.uuid(term)) } },
            {
              title: {
                [Op.or]: filter.news_article.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },



    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.note) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'article_bookmarks',
                        'note',
                        filter.note,
                    ),
                };
            }
            

            
            

            
            if (filter.bookmarked_atRange) {
                const [start, end] = filter.bookmarked_atRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    bookmarked_at: {
                    ...where.bookmarked_at,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    bookmarked_at: {
                    ...where.bookmarked_at,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            


      

      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.article_bookmarks.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset, ) {
        let where = {};
        
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'article_bookmarks',
                        'note',
                        query,
                    ),
                ],
            };
        }

        const records = await db.article_bookmarks.findAll({
            attributes: [ 'id', 'note' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['note', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.note,
        }));
    }

    
};

